#include "cdialog_main.h"

//-   ----------------------------------------
BEGIN_MESSAGE_MAP(CDialog_Main,CDialog)
 ON_WM_DESTROY()
 ON_WM_CLOSE()
 ON_WM_PAINT()
 ON_WM_TIMER()
 ON_COMMAND(IDC_BUTTON_MAIN_SAVE_FRAME,OnButton_SaveFrame)
 ON_COMMAND(IDC_BUTTON_MAIN_SAVE_ALL_FRAME,OnButton_SaveAllFrame)
 ON_COMMAND(IDC_BUTTON_MAIN_SAVE_IMAGE_NO_SCALE,OnButton_SaveImageNoScale)
 ON_COMMAND(IDC_BUTTON_MAIN_SAVE_IMAGE_CROSS,OnButton_SaveImageCross)
 ON_COMMAND(IDC_BUTTON_MAIN_SAVE_RAW,OnButton_SaveRAW)
 ON_COMMAND(IDC_BUTTON_MAIN_APPLY_PALETTE,OnButton_ApplyPalette)
END_MESSAGE_MAP()
//- --------------------------------------------------------
CDialog_Main::CDialog_Main(LPCTSTR lpszTemplateName, CWnd* pParentWnd):CDialog(lpszTemplateName,pParentWnd)
{
 long n;
 ViewImagePtr=new unsigned long[IMAGE_VIEW_WIDTH*IMAGE_VIEW_HEIGHT];
 for(n=0;n<IMAGE_VIEW_WIDTH*IMAGE_VIEW_HEIGHT;n++) ViewImagePtr[n]=0;

 SaveViewImagePtr=new unsigned long[IMAGE_VIEW_WIDTH*IMAGE_VIEW_HEIGHT];
 for(n=0;n<IMAGE_VIEW_WIDTH*IMAGE_VIEW_HEIGHT;n++) SaveViewImagePtr[n]=0;

 ColorImagePtr=new unsigned long[IMAGE_WIDTH*IMAGE_HEIGHT];
 for(n=0;n<IMAGE_WIDTH*IMAGE_HEIGHT;n++) ColorImagePtr[n]=0;

 ThermalImagePtr=new unsigned short[IMAGE_WIDTH*IMAGE_HEIGHT];
 for(n=0;n<IMAGE_WIDTH*IMAGE_HEIGHT;n++)ThermalImagePtr[n]=0;

 TemperatureImagePtr=new float[IMAGE_WIDTH*IMAGE_HEIGHT];
 for(n=0;n<IMAGE_WIDTH*IMAGE_HEIGHT;n++)TemperatureImagePtr[n]=0;

 cGraphics.Init(ViewImagePtr,IMAGE_VIEW_WIDTH,IMAGE_VIEW_HEIGHT);

 LastReceivedFrameIndex=0;

 cFlirOneControl.LoadColorMap("iron.pal");// 

 PlanckR1=16528.178;
 PlanckB=1427.5;
 PlanckF=1.0;
 PlanckO=-1307.0;
 PlanckR2=0.012258549;

 TempReflected=20;
 Emissivity=0.95;

 SaveAllFrame=false;
 SaveImageNoScale=false;
 SaveImageCross=false;
 SaveRAW=false;
}
//- ---------------------------------------------------------
CDialog_Main::~CDialog_Main()
{
 delete[](ViewImagePtr);
 delete[](SaveViewImagePtr);
 delete[](ColorImagePtr);
 delete[](ThermalImagePtr);
 delete[](TemperatureImagePtr);
}
//-  -------------------------------------------------
afx_msg void CDialog_Main::OnOK(void)
{
}
afx_msg void CDialog_Main::OnCancel(void)
{
}
afx_msg void CDialog_Main::OnClose(void)
{
 EndDialog(0);
}
afx_msg BOOL CDialog_Main::OnInitDialog(void)
{
 ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER))->SetWindowText("");
 ((CEdit *)GetDlgItem(IDC_EDIT_MAIN_TEMPERATURE))->SetWindowText("20");
 ((CEdit *)GetDlgItem(IDC_EDIT_MAIN_EMISSION))->SetWindowText("0.95");
 ((CEdit *)GetDlgItem(IDC_EDIT_MAIN_TEMPERATURE))->SetLimitText(10);
 ((CEdit *)GetDlgItem(IDC_EDIT_MAIN_EMISSION))->SetLimitText(10);
 
 cColorButton_SaveAllFrame.Attach(IDC_BUTTON_MAIN_SAVE_ALL_FRAME,this); 
 cColorButton_SaveAllFrame.SetBackGroundColor(RGB(192,192,192));

 cColorButton_SaveImageNoScale.Attach(IDC_BUTTON_MAIN_SAVE_IMAGE_NO_SCALE,this); 
 cColorButton_SaveImageNoScale.SetBackGroundColor(RGB(192,192,192));

 cColorButton_SaveImageCross.Attach(IDC_BUTTON_MAIN_SAVE_IMAGE_CROSS,this); 
 cColorButton_SaveImageCross.SetBackGroundColor(RGB(192,192,192));

 cColorButton_SaveRAW.Attach(IDC_BUTTON_MAIN_SAVE_RAW,this); 
 cColorButton_SaveRAW.SetBackGroundColor(RGB(192,192,192));

 // 
 ((CComboBox *)GetDlgItem(IDC_COMBO_MAIN_PALETTE))->ResetContent();
 vector_PaletteFileName.clear();
 WIN32_FIND_DATA wfd;
 //  
 HANDLE Handle_Find=FindFirstFile("*.pal",&wfd);
 if (Handle_Find!=INVALID_HANDLE_VALUE)
 {
  while(1)
  {
   // 
   if (wfd.cFileName[0]!='.' && !(wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
   {
    //  
	((CComboBox *)GetDlgItem(IDC_COMBO_MAIN_PALETTE))->AddString(wfd.cFileName);
	vector_PaletteFileName.push_back(string(wfd.cFileName));
   }
   if (FindNextFile(Handle_Find,&wfd)==FALSE) break;
  }
  FindClose(Handle_Find);
 }
 ((CComboBox *)GetDlgItem(IDC_COMBO_MAIN_PALETTE))->SetCurSel(0);

 // 
 SetTimer(ID_TIMER_UPDATE,30,NULL);
 return(CDialog::OnInitDialog());
}
//-  ------------------------------------------------------
//-   ----------------------------------------
afx_msg void CDialog_Main::OnDestroy(void)
{
 KillTimer(ID_TIMER_UPDATE);
 CDialog::OnDestroy();
}
afx_msg void CDialog_Main::OnTimer(UINT nIDEvent)
{
 long x;
 long y;
 if (nIDEvent==ID_TIMER_UPDATE) 
 {
  //     
  char string[255];
  ((CEdit *)GetDlgItem(IDC_EDIT_MAIN_TEMPERATURE))->GetWindowText(string,255);
  TempReflected=atof(string);
  ((CEdit *)GetDlgItem(IDC_EDIT_MAIN_EMISSION))->GetWindowText(string,255);
  Emissivity=atof(string);
  // 
  unsigned long index;
  //  
  cFlirOneControl.CopyThermalImage(ThermalImagePtr,THERMAL_IMAGE_SIZE_SHORT,index);
  //  
  cFlirOneControl.CopyColorImage(ColorImagePtr,COLOR_IMAGE_SIZE_LONG,index);
  
  if (LastReceivedFrameIndex!=index)// 
  {
   // 
   unsigned long *v1_ptr=ViewImagePtr;
   unsigned long *v2_ptr=ColorImagePtr;
   for(y=0;y<IMAGE_HEIGHT;y++,v1_ptr+=IMAGE_VIEW_WIDTH,v2_ptr+=IMAGE_WIDTH)
   {
    unsigned long *v1_ptr_local=v1_ptr;
    unsigned long *v2_ptr_local=v2_ptr;
    for(x=0;x<IMAGE_WIDTH;x++,v1_ptr_local++,v2_ptr_local++) *v1_ptr_local=*v2_ptr_local;
   }
   //      
   cGraphics.SolidFill(IMAGE_WIDTH+2,IMAGE_HEIGHT-FONT_HEIGHT*2-2-4,IMAGE_VIEW_WIDTH-(IMAGE_WIDTH+2),FONT_HEIGHT*2+4,0);
   cGraphics.SolidFill(IMAGE_WIDTH+2,2,IMAGE_VIEW_WIDTH-(IMAGE_WIDTH+2),FONT_HEIGHT,0);
   //  
   unsigned long scale_height=IMAGE_VIEW_HEIGHT-8-FONT_HEIGHT*3-4;
   float c_index=255.0f;
   float dc_index=255.0f/static_cast<float>(scale_height);
   v1_ptr=ViewImagePtr+(4+FONT_HEIGHT)*IMAGE_VIEW_WIDTH+IMAGE_WIDTH+2;
   unsigned char R[256];
   unsigned char G[256];
   unsigned char B[256];
   cFlirOneControl.CopyColorMap(R,G,B,256);
   for(y=0;y<scale_height;y++,v1_ptr+=IMAGE_VIEW_WIDTH,c_index-=dc_index)
   {    
	unsigned long index=static_cast<unsigned long>(c_index);
	unsigned long color=0;
    color|=0xff;
	color<<=8;
    color|=R[index];
	color<<=8;
    color|=G[index];
	color<<=8;
    color|=B[index];
	unsigned long *v1_ptr_local=v1_ptr;
    for(x=0;x<IMAGE_VIEW_WIDTH-IMAGE_WIDTH-4;x++,v1_ptr_local++) *v1_ptr_local=color;
   }
   //   
   char string[255];
   double t_max=-10000;
   double t_min=10000;
   double t=0;
   long point=0;// 
   unsigned short *t_ptr=ThermalImagePtr;
   float *tmr_ptr=TemperatureImagePtr;
   unsigned long *v_ptr=ViewImagePtr;
   for(y=0;y<IMAGE_HEIGHT;y++,v_ptr+=IMAGE_VIEW_WIDTH)
   {
    unsigned long *v_ptr_local=v_ptr;
    for(x=0;x<IMAGE_WIDTH;x++,t_ptr++,v_ptr_local++,tmr_ptr++)
	{
	 // 
     double pt;//  
	 *tmr_ptr=-100000;
	 if (GetTemperature(*t_ptr,pt)==false) continue;//  
	 *tmr_ptr=pt;
	 if (pt>t_max) t_max=pt;
	 if (pt<t_min) t_min=pt;
	 if (x>=IMAGE_WIDTH/2-FRAME_SIZE && x<=IMAGE_WIDTH/2+FRAME_SIZE)
	 {
      if (y>=IMAGE_HEIGHT/2-FRAME_SIZE && y<=IMAGE_HEIGHT/2+FRAME_SIZE)
	  {
       point++;
	   t+=pt;
	  }
	 }
	}
   }
   if (point!=0)
   {
    t/=static_cast<double>(point);
    // 
	if (t>=-999 && t<=999)
	{
     sprintf(string,"%.1f",t);
     ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER))->SetWindowText(string);   	
     sprintf(string,"%.1f!",t);
	 cGraphics.PutString(IMAGE_WIDTH+2,IMAGE_VIEW_HEIGHT-FONT_HEIGHT-2,string,0xFFFFFF);
	}
   }
   else ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER))->SetWindowText("");   
   //  
   if (t_min>=-999 && t_min<=999)
   {
    sprintf(string,"%.1f!",t_min);
    cGraphics.PutString(IMAGE_WIDTH+2,IMAGE_VIEW_HEIGHT-FONT_HEIGHT*2-2-4,string,0xFFFFFF);
   }
   //  
   if (t_max>=-999 && t_max<=999)
   {
    sprintf(string,"%.1f!",t_max);
 	cGraphics.PutString(IMAGE_WIDTH+2,2,string,0xFFFFFF);
   }
   if (SaveImageCross==false) memcpy(SaveViewImagePtr,ViewImagePtr,IMAGE_VIEW_WIDTH*IMAGE_VIEW_HEIGHT*sizeof(unsigned long));
   // 
   unsigned long *v_ptr_horizontal=ViewImagePtr+(IMAGE_VIEW_HEIGHT/2-FRAME_SIZE)*IMAGE_VIEW_WIDTH+IMAGE_WIDTH/2-FRAME_SIZE;
   unsigned long *v_ptr_vertical=v_ptr_horizontal;
   for(long n=0;n<=FRAME_SIZE*2;n++,v_ptr_horizontal++,v_ptr_vertical+=IMAGE_VIEW_WIDTH)
   {
    *v_ptr_horizontal^=0x00FFFFFF;
    *(v_ptr_horizontal+FRAME_SIZE*2*IMAGE_VIEW_WIDTH)^=0x00FFFFFF;
    if (v_ptr_horizontal==v_ptr_vertical) continue;
	if (v_ptr_horizontal+FRAME_SIZE*2*IMAGE_VIEW_WIDTH==v_ptr_vertical+FRAME_SIZE*2) continue;
    *v_ptr_vertical^=0x00FFFFFF;
    *(v_ptr_vertical+FRAME_SIZE*2)^=0x00FFFFFF;
   }
   if (SaveImageCross==true) memcpy(SaveViewImagePtr,ViewImagePtr,IMAGE_VIEW_WIDTH*IMAGE_VIEW_HEIGHT*sizeof(unsigned long));
   if (SaveAllFrame==true) OnButton_SaveFrame();// 
  }
  LastReceivedFrameIndex=index;
  InvalidateRect(NULL,FALSE);
 }
 CDialog::OnTimer(nIDEvent);
}
afx_msg void CDialog_Main::OnPaint(void)
{
 CDialog::OnPaint();
 CPaintDC cPaintDC(((CStatic *)GetDlgItem(IDC_STATIC_MAIN)));

 CRect cRect;
 ((CStatic *)GetDlgItem(IDC_STATIC_MAIN))->GetClientRect(&cRect);
 //  
 long width=cRect.right-cRect.left;
 long height=cRect.bottom-cRect.top;
 
 if (width<height) width=height*IMAGE_VIEW_WIDTH/IMAGE_VIEW_HEIGHT;
              else height=width*IMAGE_VIEW_HEIGHT/IMAGE_VIEW_WIDTH;
 cRect.right=cRect.left+width;
 cRect.bottom=cRect.top+height;
 
 BITMAPINFOHEADER bmih;
 bmih.biSize=sizeof(BITMAPINFOHEADER);
 bmih.biWidth=IMAGE_VIEW_WIDTH;
 bmih.biHeight=-IMAGE_VIEW_HEIGHT;
 bmih.biPlanes=1;
 bmih.biBitCount=32;
 bmih.biCompression=BI_RGB;
 bmih.biSizeImage=0;
 bmih.biXPelsPerMeter=300;
 bmih.biYPelsPerMeter=300;
 bmih.biClrUsed=0;
 bmih.biClrImportant=0;
 RGBQUAD rgbq;
 BITMAPINFO info;
 rgbq.rgbBlue=1;
 rgbq.rgbGreen=0;
 rgbq.rgbRed=0;
 rgbq.rgbReserved=0;
 info.bmiHeader=bmih;
 info.bmiColors[0]=rgbq;

 StretchDIBits(cPaintDC,cRect.left,cRect.top,cRect.right-cRect.left,cRect.bottom-cRect.top,0,0,abs(bmih.biWidth),abs(bmih.biHeight),ViewImagePtr,&info,DIB_RGB_COLORS,SRCCOPY);
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
afx_msg void CDialog_Main::OnButton_SaveFrame(void)
{
 SaveColorImage();
 if (SaveRAW==true) SaveThermalImage();
}
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
afx_msg void CDialog_Main::OnButton_SaveAllFrame(void)
{
 if (SaveAllFrame==true) 
 {
  SaveAllFrame=false;
  cColorButton_SaveAllFrame.SetBackGroundColor(RGB(192,192,192));
 }
 else
 {
  SaveAllFrame=true;
  cColorButton_SaveAllFrame.SetBackGroundColor(RGB(128,255,128));
 }
}
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
afx_msg void CDialog_Main::OnButton_SaveImageNoScale(void)
{
 if (SaveImageNoScale==true) 
 {
  SaveImageNoScale=false;
  cColorButton_SaveImageNoScale.SetBackGroundColor(RGB(192,192,192));
 }
 else
 {
  SaveImageNoScale=true;
  cColorButton_SaveImageNoScale.SetBackGroundColor(RGB(128,255,128));
 }
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
afx_msg void CDialog_Main::OnButton_SaveImageCross(void)
{
 if (SaveImageCross==true) 
 {
  SaveImageCross=false;
  cColorButton_SaveImageCross.SetBackGroundColor(RGB(192,192,192));
 }
 else
 {
  SaveImageCross=true;
  cColorButton_SaveImageCross.SetBackGroundColor(RGB(128,255,128));
 }
}
//---------------------------------------------------------------------------
// RAW
//---------------------------------------------------------------------------
afx_msg void CDialog_Main::OnButton_SaveRAW(void)
{
 if (SaveRAW==true) 
 {
  SaveRAW=false;
  cColorButton_SaveRAW.SetBackGroundColor(RGB(192,192,192));
 }
 else
 {
  SaveRAW=true;
  cColorButton_SaveRAW.SetBackGroundColor(RGB(128,255,128));
 }
}

//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
afx_msg void CDialog_Main::OnButton_ApplyPalette(void)
{
 long index=((CComboBox *)GetDlgItem(IDC_COMBO_MAIN_PALETTE))->GetCurSel();
 if (vector_PaletteFileName.size()<=index) return;
 cFlirOneControl.LoadColorMap(const_cast<char*>(vector_PaletteFileName[index].c_str())); 
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
bool CDialog_Main::GetTemperature(unsigned short raw14,double &value)
{
 if (raw14>0x10000) return(false);
 raw14*=4;    
 double zn=(PlanckR2*(exp(PlanckB/(TempReflected+273.15))-PlanckF));
 if (fabs(zn)<EPS) return(false);
 double RAWrefl=PlanckR1/zn-PlanckO;
 double RAWobj=(raw14-(1-Emissivity)*RAWrefl)/Emissivity;
 double lgr=PlanckR1/(PlanckR2*(RAWobj+PlanckO)+PlanckF);
 if (lgr<=EPS) return(false);
 value=PlanckB/log(lgr)-273.15; 
 return(true);
}

//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void CDialog_Main::SaveColorImage(void)
{
 CreateDirectory("Image",NULL);
 //   
 time_t time_main=time(NULL);
 tm *tm_main=localtime(&time_main);
 //  
 char filename[1024];
 for(long index=1;index<1000;index++)	
 {
  sprintf(filename,"Image\\img[%04i.%02i.%02i %02i_%02i_%02i-%03ld].tga",tm_main->tm_year+1900,tm_main->tm_mon+1,tm_main->tm_mday,tm_main->tm_hour,tm_main->tm_min,tm_main->tm_sec,index);
  FILE *file=fopen(filename,"rb");
  if (file==NULL)//   
  {
   if (SaveImageNoScale==false) SaveTGA(filename,IMAGE_VIEW_WIDTH,IMAGE_VIEW_HEIGHT,reinterpret_cast<unsigned char*>(SaveViewImagePtr));
                           else SaveTGA(filename,IMAGE_WIDTH,IMAGE_HEIGHT,reinterpret_cast<unsigned char*>(ColorImagePtr));
   break;
  }
  else fclose(file);     
 }
}
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void CDialog_Main::SaveThermalImage(void)
{
 CreateDirectory("Image",NULL);
 //   
 time_t time_main=time(NULL);
 tm *tm_main=localtime(&time_main);
 //  
 char filename[1024];
 for(long index=1;index<1000;index++)	
 {
  sprintf(filename,"Image\\img[%04i.%02i.%02i %02i_%02i_%02i-%03ld].raw",tm_main->tm_year+1900,tm_main->tm_mon+1,tm_main->tm_mday,tm_main->tm_hour,tm_main->tm_min,tm_main->tm_sec,index);
  FILE *file=fopen(filename,"rb");
  if (file==NULL)//   
  {
   file=fopen(filename,"wb");
   #pragma pack(1)
   struct SHeader
   {
    unsigned long Width;//
	unsigned long Height;//
    //   
    double PlanckR1;
    double PlanckB;
    double PlanckF;
    double PlanckO;
    double PlanckR2;
    double TempReflected;// 
    double Emissivity;// 
   } sHeader;
   #pragma pack()
   sHeader.Width=IMAGE_WIDTH;
   sHeader.Height=IMAGE_HEIGHT;
   sHeader.PlanckR1=PlanckR1;
   sHeader.PlanckB=PlanckB;
   sHeader.PlanckF=PlanckF;
   sHeader.PlanckO=PlanckO;
   sHeader.PlanckR2=PlanckR2;
   sHeader.TempReflected=TempReflected;
   sHeader.Emissivity=Emissivity;
   fwrite(&sHeader,1,sizeof(SHeader),file);// 
   // 
   fwrite(ThermalImagePtr,THERMAL_IMAGE_SIZE_SHORT,sizeof(unsigned short),file);
   fclose(file);  	
   break;
  }
  else fclose(file);     
 }
}

//-  ------------------------------------------------------
