#ifndef CFLIRONECONTROL_H
#define CFLIRONECONTROL_H

#include "stdafx.h"
#include "tga.h"
#include <setupapi.h>
#include <basetyps.h>
#include <assert.h>

#define IMAGE_BUFFER_SIZE 1048576

//   ( )
#define ORIGINAL_IMAGE_WIDTH 160
#define ORIGINAL_IMAGE_HEIGHT 120

//        
#define IMAGE_WIDTH 120
#define IMAGE_HEIGHT 160

#define THERMAL_IMAGE_SIZE_SHORT (IMAGE_WIDTH*IMAGE_HEIGHT)
#define COLOR_IMAGE_SIZE_LONG (IMAGE_WIDTH*IMAGE_HEIGHT)

// 
#define EPS 0.00000001

//   
#define MAX_DEVPATH_LENGTH 256

//   iAP
//  Frame
#define IOCTL_FLIR_ONE_GEN2_FRAME_STOP		1
//  Frame
#define IOCTL_FLIR_ONE_GEN2_FRAME_START		2
//  FileIO
#define IOCTL_FLIR_ONE_GEN2_FILEIO_STOP		4
//  FileIO
#define IOCTL_FLIR_ONE_GEN2_FILEIO_START	8

//  Flir One
class CFlirOneControl
{
 protected:
  //- -------------------------------------------------------  
  HANDLE hFile_FileIO;// FileIO
  HANDLE hFile_Frame;// Frame
  HANDLE hFile_iAP;// iAP

  OVERLAPPED Overlapped_FileIO;//   FileIO
  OVERLAPPED Overlapped_Frame;//   Frame
  OVERLAPPED Overlapped_iAP;//   iAP

  bool Start_FileIO;
  bool Start_Frame;
  bool Start_iAP;

  char *Data;
  unsigned long SizeOfData;

  unsigned char *ImageBuffer;//     
  unsigned long ImageBufferSize;//     

  long Delay;//   
  struct SProtected
  {
   CCriticalSection cCriticalSection;//     
   //  
   unsigned char ColorMap_R[256];
   unsigned char ColorMap_G[256];
   unsigned char ColorMap_B[256];

   unsigned short *ThermalImage;//  (raw14)
   unsigned long *ColorImage;// 
   float *TemperatureImage;// 
   long FrameIndex;//  
  } sProtected;// 

  CEvent cEvent_Exit;//  
  CWinThread *cWinThread_ProcessingThread;//   
  //- ----------------------------------------------------------
  //-------------------------------------------------------------------
 public:
  //- ------------------------------------------------------
  CFlirOneControl(void);
  //- -------------------------------------------------------
  ~CFlirOneControl();
  //- -------------------------------------------------------
  //- ----------------------------------------------------------
  bool Open(void);//  
  void Close(void);//  
  bool Processing(void);// (  )
  bool LoadColorMap(char *filename);//   
  bool CopyColorImage(unsigned long *image_ptr,unsigned long size,unsigned long &index);//    
  bool CopyThermalImage(unsigned short *image_ptr,unsigned long size,unsigned long &index);//    
  bool CopyColorMap(unsigned char R[256],unsigned char G[256],unsigned char B[256],unsigned long size);// 
  //-------------------------------------------------------------------
 protected:
  void CalculateCRC(unsigned short &crc,unsigned char byte);// crc
  void AddLog(char *string);//   log-
  void AddLog(long value);//   log-
  bool CreateImage(unsigned char *buffer,unsigned long size);// 
  bool SendControlCommand(unsigned long code);//  
  bool GetDevicePath(IN LPGUID InterfaceGuid,PCHAR DevicePath,size_t BufLen);//   GUID
  void StartThread(void);// 
  void StopThread(void);// 
  bool ReadStream(void);//    
};

UINT ProcessingThread(LPVOID pParam);// 

#endif
